? compile-string-for-emacs.patch
? eliminate-undefine-variable-warnings.patch
? eliminate-undefined-variable-warnings.patch
? set-key-adds-command-to-table.patch
Index: bordered-output.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/bordered-output.lisp,v
retrieving revision 1.17
diff -u -r1.17 bordered-output.lisp
--- bordered-output.lisp	20 Mar 2007 01:41:17 -0000	1.17
+++ bordered-output.lisp	30 Apr 2009 11:10:36 -0000
@@ -42,6 +42,24 @@
 
 (in-package :clim-internals)
 
+
+;;; Default Color Scheme Options
+
+#||
+;; Motif-ish
+(defparameter *3d-dark-color*   (make-gray-color .45))
+(defparameter *3d-normal-color* (make-gray-color .75))
+(defparameter *3d-light-color*  (make-gray-color .92))
+(defparameter *3d-inner-color*  (make-gray-color .65))
+||#
+
+;; Gtk-ish
+
+(defparameter *3d-dark-color*   (make-gray-color .59))
+(defparameter *3d-normal-color* (make-gray-color .84))
+(defparameter *3d-light-color*  (make-gray-color 1.0))
+(defparameter *3d-inner-color*  (make-gray-color .75))
+
 (defclass bordered-output-record (standard-sequence-output-record)
   (under record over))
 
Index: commands.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/commands.lisp,v
retrieving revision 1.83
diff -u -r1.83 commands.lisp
--- commands.lisp	28 Feb 2009 16:48:16 -0000	1.83
+++ commands.lisp	30 Apr 2009 11:10:36 -0000
@@ -21,6 +21,9 @@
 
 (in-package :clim-internals)
 
+(defvar *unsupplied-argument-marker* '%unsupplied-argument-marker%)
+(defvar *numeric-argument-marker* '%numeric-argument-marker%)
+
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;
 ;;; Command tables
@@ -611,6 +614,9 @@
 		   (values sub-item sub-command-table))))))
        command-table))))
 
+(defparameter *command-parser-table* (make-hash-table)
+  "Mapping from command names to argument parsing functions.")
+
 (defun partial-command-from-name (command-name command-table)
   (let ((parser (gethash command-name *command-parser-table*)))
     (if (null parser)
@@ -668,12 +674,6 @@
   (:documentation "A container for a command's parsing functions and
   data for unparsing"))
 
-(defparameter *command-parser-table* (make-hash-table)
-  "Mapping from command names to argument parsing functions.")
-
-(defvar *unsupplied-argument-marker* '%unsupplied-argument-marker%)
-(defvar *numeric-argument-marker* '%numeric-argument-marker%)
-
 (defvar *command-name-delimiters* '(command-delimiter))
 
 (defvar *command-argument-delimiters* '(command-delimiter))
Index: design.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/design.lisp,v
retrieving revision 1.29
diff -u -r1.29 design.lisp
--- design.lisp	14 Apr 2008 16:46:37 -0000	1.29
+++ design.lisp	30 Apr 2009 11:10:36 -0000
@@ -295,7 +295,10 @@
 ;;; of methods necessary. 
 
 (defclass everywhere-mixin () ())
-(defclass nowhere-mixin    () ()) 
+(defclass nowhere-mixin    () ())
+
+(declaim (special +everywhere+ +nowhere+))
+
 ;;;;
 ;;;; 13.6 Indirect Inks
 ;;;;
Index: frames.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/frames.lisp,v
retrieving revision 1.136
diff -u -r1.136 frames.lisp
--- frames.lisp	28 Feb 2009 16:49:40 -0000	1.136
+++ frames.lisp	30 Apr 2009 11:10:37 -0000
@@ -312,8 +312,6 @@
 (defmethod frame-error-output ((frame application-frame))
   (frame-standard-output frame))
 
-(defvar *pointer-documentation-output* nil)
-
 (defmethod frame-pointer-documentation-output ((frame application-frame))
   (find-pane-of-type (frame-panes frame) 'pointer-documentation-pane))
 
@@ -1138,6 +1136,10 @@
 (defgeneric frame-print-pointer-documentation
     (frame input-context stream state event))
 
+(defvar *background-message-minimum-lifetime* 1
+  "The amount of seconds a background message will be kept
+alive.")
+
 (defmethod frame-print-pointer-documentation
     ((frame standard-application-frame) input-context stream state event)
   (unless state
Index: package.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/package.lisp,v
retrieving revision 1.70
diff -u -r1.70 package.lisp
--- package.lisp	21 Aug 2008 22:34:28 -0000	1.70
+++ package.lisp	30 Apr 2009 11:10:38 -0000
@@ -2071,7 +2071,7 @@
   (:nicknames :climi)
   #+excl
   (:import-from :excl compile-system load-system)
-  (:intern #:letf))
+  (:intern #:letf #:*active-history-type*))
 
 ;(defpackage :CLIM
 ;  (:use #+nil :clim-extensions ; will use it later
@@ -2100,7 +2100,7 @@
 
 (defpackage :goatee
   (:use :clim :clim-lisp :clim-sys)
-  (:import-from :clim-internals #:letf)
+  (:import-from :clim-internals #:letf #:*active-history-type*)
   (:shadow #:point)
   (:export
    #:execute-gesture-command
Index: panes.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/panes.lisp,v
retrieving revision 1.194
diff -u -r1.194 panes.lisp
--- panes.lisp	19 Dec 2008 08:58:14 -0000	1.194
+++ panes.lisp	30 Apr 2009 11:10:39 -0000
@@ -177,25 +177,6 @@
   (setf (get abstract-class-name 'concrete-pane-class-name)
         concrete-class-name))
 
-
-
-;;; Default Color Scheme Options
-
-#||
-;; Motif-ish
-(defparameter *3d-dark-color*   (make-gray-color .45))
-(defparameter *3d-normal-color* (make-gray-color .75))
-(defparameter *3d-light-color*  (make-gray-color .92))
-(defparameter *3d-inner-color*  (make-gray-color .65))
-||#
-
-;; Gtk-ish
-
-(defparameter *3d-dark-color*   (make-gray-color .59))
-(defparameter *3d-normal-color* (make-gray-color .84))
-(defparameter *3d-light-color*  (make-gray-color 1.0))
-(defparameter *3d-inner-color*  (make-gray-color .75))
-
 ;;; Gadget "Feel"
 
 (defparameter *double-click-delay* 0.25
@@ -2742,9 +2723,6 @@
 
 (defparameter *default-pointer-documentation-background* +black+)
 (defparameter *default-pointer-documentation-foreground* +white+)
-(defvar *background-message-minimum-lifetime* 1
-  "The amount of seconds a background message will be kept
-alive.")
 
 (defclass pointer-documentation-pane (clim-stream-pane)
   ((background-message :initform nil
Index: presentation-defs.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/presentation-defs.lisp,v
retrieving revision 1.80
diff -u -r1.80 presentation-defs.lisp
--- presentation-defs.lisp	21 Jan 2009 06:48:08 -0000	1.80
+++ presentation-defs.lisp	30 Apr 2009 11:10:40 -0000
@@ -690,7 +690,6 @@
 
 (defvar *recursive-accept-p* nil)
 (defvar *recursive-accept-1-p* nil)
-(defvar *active-history-type* nil)
 
 ;;; The spec says "default-type most be a presentation type specifier", but the
 ;;; examples we have imply that default-type is optional, so we'll be liberal
Index: presentations.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/presentations.lisp,v
retrieving revision 1.85
diff -u -r1.85 presentations.lisp
--- presentations.lisp	1 Feb 2008 17:02:55 -0000	1.85
+++ presentations.lisp	30 Apr 2009 11:10:40 -0000
@@ -1924,6 +1924,8 @@
   presentation
   context)
 
+(defvar *pointer-documentation-output* nil)
+
 (defun call-presentation-menu
     (presentation input-context frame window x y
      &key (for-menu t) label)
Index: recording.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/recording.lisp,v
retrieving revision 1.142
diff -u -r1.142 recording.lisp
--- recording.lisp	19 Aug 2008 15:56:50 -0000	1.142
+++ recording.lisp	30 Apr 2009 11:10:41 -0000
@@ -69,6 +69,8 @@
 
 (in-package :clim-internals)
 
+(defvar *active-history-type* nil)
+
 ;;; 16.2.1. The Basic Output Record Protocol
 #+:cmu(declaim (ftype (function (output-record) (values rational rational))
 		      output-record-position))
Index: regions.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/regions.lisp,v
retrieving revision 1.38
diff -u -r1.38 regions.lisp
--- regions.lisp	23 Jan 2008 22:37:08 -0000	1.38
+++ regions.lisp	30 Apr 2009 11:10:42 -0000
@@ -4,7 +4,7 @@
 ;;;   Created: 1998-12-02 19:26
 ;;;    Author: Gilbert Baumann <unk6@rz.uni-karlsruhe.de>
 ;;;   License: LGPL (See file COPYING for details).
-;;;       $Id: regions.lisp,v 1.38 2008-01-23 22:37:08 thenriksen Exp $
+;;;       $Id: regions.lisp,v 1.38 2008/01/23 22:37:08 thenriksen Exp $
 ;;; --------------------------------------------------------------------------------------
 ;;;  (c) copyright 1998,1999,2001 by Gilbert Baumann
 ;;;  (c) copyright 2001 by Arnaud Rouanet (rouanet@emi.u-bordeaux.fr)
Index: stream-input.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/stream-input.lisp,v
retrieving revision 1.55
diff -u -r1.55 stream-input.lisp
--- stream-input.lisp	20 Apr 2009 09:45:23 -0000	1.55
+++ stream-input.lisp	30 Apr 2009 11:10:42 -0000
@@ -131,6 +131,10 @@
 every gesture on, but accenting the final one as per the dead
 keys read."))
 
+(defvar *input-wait-test* nil)
+(defvar *input-wait-handler* nil)
+(defvar *pointer-button-press-handler* nil)
+
 (defmethod stream-read-gesture :around
     ((stream dead-key-merging-mixin)
      &key timeout peek-p
@@ -182,10 +186,6 @@
   stream-read-gesture (not peek-p), untransformed, so it can easily be
   unread.")))
 
-(defvar *input-wait-test* nil)
-(defvar *input-wait-handler* nil)
-(defvar *pointer-button-press-handler* nil)
-
 (defmacro with-input-focus ((stream) &body body)
   (when (eq stream t)
     (setq stream '*standard-input*))
Index: Backends/PostScript/graphics.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/Backends/PostScript/graphics.lisp,v
retrieving revision 1.20
diff -u -r1.20 graphics.lisp
--- Backends/PostScript/graphics.lisp	28 Aug 2007 14:50:25 -0000	1.20
+++ Backends/PostScript/graphics.lisp	30 Apr 2009 11:10:43 -0000
@@ -39,6 +39,9 @@
 
 (in-package :clim-postscript)
 
+(defvar *transformation* nil
+  "Native transformation")
+
 ;;; Postscript output utilities
 (defun write-number (stream number)
   (format stream "~,3F " (coerce number 'single-float)))
@@ -165,8 +168,6 @@
       (format stream "pe~%"))))
 
 ;;;;
-(defvar *transformation* nil
-  "Native transformation")
 
 ;;; Postscript output utilities
 (defmacro with-graphics-state ((stream) &body body)
Index: Drei/lisp-syntax.lisp
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/Drei/lisp-syntax.lisp,v
retrieving revision 1.79
diff -u -r1.79 lisp-syntax.lisp
--- Drei/lisp-syntax.lisp	17 Jul 2008 08:48:48 -0000	1.79
+++ Drei/lisp-syntax.lisp	30 Apr 2009 11:10:44 -0000
@@ -46,6 +46,10 @@
 (define-syntax-command-table lisp-table
     :errorp nil)
 
+(define-parser-state |form* | (lexer-toplevel-state parser-state) ())
+(define-parser-state form-may-follow (lexer-toplevel-state parser-state) ())
+(define-parser-state |initial-state | (form-may-follow) ())
+
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;
 ;;; the syntax object
@@ -682,10 +686,6 @@
 ;;; parse trees
 (defclass form* (lisp-nonterminal) ())
 
-(define-parser-state |form* | (lexer-toplevel-state parser-state) ())
-(define-parser-state form-may-follow (lexer-toplevel-state parser-state) ())
-(define-parser-state |initial-state | (form-may-follow) ())
-
 (define-new-lisp-state (|initial-state | form) |initial-state |)
 (define-new-lisp-state (|initial-state | comment) |initial-state |)
 ;; skip over unmatched right parentheses