Index: mcclim.asd
===================================================================
RCS file: /project/mcclim/cvsroot/mcclim/mcclim.asd,v
retrieving revision 1.63
diff -u -p -r1.63 mcclim.asd
--- mcclim.asd	8 Dec 2007 08:53:59 -0000	1.63
+++ mcclim.asd	17 Dec 2007 15:52:47 -0000
@@ -377,6 +377,71 @@
                (:file "graft" :depends-on ("port" "package"))
                (:file "frame-manager" :depends-on ("medium" "port" "package"))))))
 
+(defsystem clim-beagle
+  :depends-on (clim)
+  :components
+  ((:module "Backends"
+            :components
+            ((:module "beagle"
+              :serial t
+              :components
+              ((:file "package")
+               (:module "native"
+                :components ((:file "lisp-bezier-path")
+                             (:file "lisp-window")
+                             (:file "lisp-window-delegate")
+                             (:file "lisp-view"
+                              :depends-on ("lisp-bezier-path"))
+                             (:file "lisp-view-additional"
+                              :depends-on ("lisp-view"))
+                             (:file "lisp-scroller")
+                             (:file "lisp-slider")
+                             (:file "lisp-button")
+                             (:file "lisp-image")))
+               (:file "cocoa-util")
+               (:module "windowing"
+                :depends-on ("native")
+                :components ((:file "port")
+                             (:file "frame-manager")
+                             (:file "mirror")
+                             (:file "graft")))
+               (:module "native-panes"
+                :components ((:file "beagle-scroll-bar-pane")
+                             (:file "beagle-slider-pane")
+                             ;; Basic buttons - not collections of buttons
+                             (:file "beagle-fundamental-button-pane")
+                             ;; Button collections (radio + checkbox)
+                             ;; (:file "beagle-button-collection-pane")
+                             (:file "scroller-pane-fix")))
+               (:module "output"
+                :depends-on ("windowing")
+                :components ((:file "medium")
+                             (:file "fonts")))
+               (:module "input"
+                :depends-on ("windowing")
+                :components ((:file "events")
+                             (:file "keysymdef")))
+               (:module "glimpse"
+                :components ((:file "glimpse")
+                             (:file "glimpse-support")
+                             (:file "glimpse-command-tables")
+                             (:file "glimpse-present-process"
+                              :depends-on ("glimpse" "glimpse-support"))
+                             (:file "glimpse-present-window"
+                              :depends-on ("glimpse" "glimpse-support"))
+                             (:file "glimpse-modeless-commands"
+                              :depends-on ("glimpse" "glimpse-support"))
+                             (:file "glimpse-process-commands"
+                              :depends-on ("glimpse" "glimpse-support"))
+                             (:file "glimpse-window-commands"
+                              :depends-on ("glimpse" "glimpse-support"))))
+               (:module "profile"
+                :components ((:file "profile")))
+               (:module "tests"
+                :components ((:file "drawing-tests")
+                             (:file "graft-tests"))))))))
+)
+
 (defsystem :clim-null
     :depends-on (:clim)
     :components
@@ -444,7 +509,7 @@
     :depends-on (:clim :clim-postscript
                  ;; If we're on an implementation that ships CLX, use
                  ;; it. Same if the user has loaded CLX already.
-                 #+(and (or sbcl scl openmcl ecl clx allegro)
+                 #+(and (or sbcl scl ecl clx allegro)
 			(not (or gtkairo clim-graphic-forms)))
 		 :clim-clx
                  #+clim-graphic-forms             :clim-graphic-forms
@@ -454,14 +519,14 @@
 
                  ;; But until it's ready, it's no use forcing users to
                  ;; cope with possible bugs.
-                 ;; #+(or openmcl mcl)          :clim-beagle
+                 #+clozure-common-lisp :clim-beagle
 
 		 #+gtkairo :clim-gtkairo
 
 		 ;; null backend
 		 :clim-null
                  )
-    :components (#-(or gtkairo clim-graphic-forms)
+    :components (#-(or gtkairo clozure-common-lisp clim-graphic-forms)
 		 (:file "Looks/pixie"
                         :pathname #.(make-pathname :directory '(:relative "Looks") :name "pixie" :type "lisp"))))
 